name: Build & Production
on:
  push:
    tags:
      - 'release-*'
    branches:
      - master

env:
  CONTAINER_REGISTRY: ghcr.io
  CONTAINER_REGISTRY_USER: ${{ secrets.GHCR_CONTAINER_REGISTRY_USER }}
  CONTAINER_REGISTRY_PASSWORD: ${{ secrets.GHCR_TOKEN }}
  CONTAINER_REGISTRY_REPO: ghcr.io/city-of-helsinki/${{ github.event.repository.name }}
  REPO_NAME: ${{ github.event.repository.name }}
  KUBECONFIG_RAW: ${{ secrets.KUBECONFIG_RAW_STABLE }}
  BUILD_ARTIFACT_FOLDER: "build_artifacts"
  SERVICE_ARTIFACT_FOLDER: "service_artifacts"
  SERVICE_PORT: 3000
       
jobs:
  build:
    if: github.ref == 'refs/heads/master' || startsWith(github.ref, 'refs/tags')
    runs-on: ubuntu-latest
    name: Build
    steps:
      - uses: actions/checkout@v2
      - name: Build
        uses: andersinno/kolga-build-action@v2
        env:
          DOCKER_IMAGE_NAME: ${{ env.REPO_NAME }}-production
          DOCKER_BUILD_ARG_OPEN_CITY_PROFILE_API_URL: "https://api.hel.fi/profiili/graphql/"
          DOCKER_BUILD_ARG_BERTH_RESERVATIONS_API_URL: "https://api.hel.fi/berths/graphql_v2/"

  production:
    if: startsWith(github.ref, 'refs/tags')
    runs-on: ubuntu-latest
    needs: build
    name: Production
    steps:
      - uses: actions/checkout@v2
      - uses: andersinno/kolga-setup-action@v2

      - name: Deploy
        uses: andersinno/kolga-deploy-action@v2
        with:
          track: 'stable'
        env:
          K8S_NAMESPACE: ${{ secrets.K8S_NAMESPACE_STABLE }}
          K8S_ADDITIONAL_HOSTNAMES: ${{ secrets.K8S_ADDITIONAL_HOSTNAMES }}
          ENVIRONMENT_URL: https://${{ secrets.ENVIRONMENT_URL_STABLE }}
          DOCKER_IMAGE_NAME: ${{ env.REPO_NAME }}-production
